package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.VuforiaImageType;
import com.izouma.awesomeadmin.service.VuforiaImageTypeService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/vuforiaImageType")
public class VuforiaImageTypeController {

    @Autowired
    private VuforiaImageTypeService vuforiaImageTypeService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(VuforiaImageType record) {
        List<VuforiaImageType> pp = vuforiaImageTypeService.getVuforiaImageTypeList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getVuforiaImageType", method = RequestMethod.GET)
    @ResponseBody
    public Result getVuforiaImageType(@RequestParam(required = false, value = "id") String id) {
        VuforiaImageType data = vuforiaImageTypeService.getVuforiaImageTypeById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(VuforiaImageType record) {
        VuforiaImageType data = vuforiaImageTypeService.getVuforiaImageType(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, VuforiaImageType record) {
        Map<String, Object> result = new HashMap<>();

        List<VuforiaImageType> pp =vuforiaImageTypeService.getVuforiaImageTypeByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(VuforiaImageType record) {
        boolean num = vuforiaImageTypeService.createVuforiaImageType(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateVuforiaImageType(VuforiaImageType record) {
        boolean num = vuforiaImageTypeService.updateVuforiaImageType(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteVuforiaImageType(VuforiaImageType record) {

        boolean num = vuforiaImageTypeService.deleteVuforiaImageType(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, VuforiaImageType record) throws Exception {

    List<VuforiaImageType> vuforiaImageTypes = vuforiaImageTypeService.getVuforiaImageTypeList(record);


        String sheetName = "vuforia_image_type";
        String titleName = "识别图类型数据表";
        String fileName = "识别图类型表";
        int columnNumber = 11;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "识别类型名称" ,   "识别类型描述" ,   "备注1" ,   "备注2" ,   "备注3"  };
        String[][] dataList = new String[vuforiaImageTypes.size()][11];

        for (int i = 0; i < vuforiaImageTypes.size(); i++) {

                        dataList[i][0] = String.valueOf(vuforiaImageTypes.get(i).getId());
                        dataList[i][1] = String.valueOf(vuforiaImageTypes.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(vuforiaImageTypes.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(vuforiaImageTypes.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(vuforiaImageTypes.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(vuforiaImageTypes.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(vuforiaImageTypes.get(i).getTypeName());
                        dataList[i][7] = String.valueOf(vuforiaImageTypes.get(i).getTypeDescribe());
                        dataList[i][8] = String.valueOf(vuforiaImageTypes.get(i).getRemark1());
                        dataList[i][9] = String.valueOf(vuforiaImageTypes.get(i).getRemark2());
                        dataList[i][10] = String.valueOf(vuforiaImageTypes.get(i).getRemark3());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

